Package org.eclipse.birt.report.model.api

# Class ReportDesignHandle

java.lang.Object
org.eclipse.birt.report.model.api.DesignElementHandle
org.eclipse.birt.report.model.api.ModuleHandleImpl
org.eclipse.birt.report.model.api.ModuleHandle
org.eclipse.birt.report.model.api.ReportDesignHandle

All Implemented Interfaces:
  `IModuleModel`, `org.eclipse.birt.report.model.elements.interfaces.IDesignElementModel`, `org.eclipse.birt.report.model.elements.interfaces.IInternalReportDesignModel`, `org.eclipse.birt.report.model.elements.interfaces.IReportDesignModel`

public class ReportDesignHandle extends ModuleHandle implements org.eclipse.birt.report.model.elements.interfaces.IReportDesignModel
Represents the overall report design. The report design defines a set of properties that describe the design as a whole like author, base and comments etc.

Besides properties, it also contains a variety of elements that make up the report. These include:

Content Item | Description
--- | ---
Code Modules | Global scripts that apply to the report as a whole.
Parameters | A list of Parameter elements that describe the data that the user can enter when running the report.
Data Sources | The connections used by the report.
Data Sets | Data sets defined in the design.
Color Palette | A set of custom color names as part of the design.
Styles | User-defined styles used to format elements in the report. Each style must have a unique name within the set of styles for this report.
Page Setup | The layout of the master pages within the report.
Components | Reusable report items defined in this design. Report items can extend these items. Defines a "private library" for this design.
Body | A list of the visual report content. Content is made up of one or more sections. A section is a report item that fills the width of the page. It can contain Text, Grid, List, Table, etc. elements
Scratch Pad | Temporary place to move report items while restructuring a report.
Translations | The list of externalized messages specifically for this report.
Images | A list of images embedded in this report.

Module allow to use the components defined in `Library`.

- User can call `ModuleHandleImpl.includeLibrary(String, String)`to include one library.
- User can create one report item based on the one in library, and add it into design file.
- User can use style, data source, and data set, which are defined in library, in design file.

                          // Include one library

                          ReportDesignHandle designHandle = ...;
                          designHandle.includeLibrary( "libA.rptlibrary", "LibA" );
                          LibraryHandle libraryHandle = designHandle.getLibrary("LibA");

                          // Create one label based on the one in library

                          LabelHandle labelHandle = (LabelHandle) libraryHandle.findElement("companyNameLabel");
                          LabelHandle myLabelHandle = (LabelHandle) designHandle.getElementFactory().newElementFrom( labelHandle, "myLabel" );

                          // Add the new label into design file

                          designHandle.getBody().add(myLabelHandle);

See Also:
  - `ReportDesign`

## Field Summary

### Fields inherited from class org.eclipse.birt.report.model.api.ModuleHandleImpl

`isInitialized`

### Fields inherited from class org.eclipse.birt.report.model.api.DesignElementHandle

`module`

### Fields inherited from interface org.eclipse.birt.report.model.elements.interfaces.IDesignElementModel

`COMMENTS_PROP, CUSTOM_XML_PROP, DISPLAY_NAME_ID_PROP, DISPLAY_NAME_PROP, EVENT_HANDLER_CLASS_PROP, EXTENDS_PROP, FULL_LABEL, ID_SUFFIX, NAME_PROP, NEW_HANDLER_ON_EACH_EVENT_PROP, NO_SLOT, PROPERTY_MASKS_PROP, REF_TEMPLATE_PARAMETER_PROP, SHORT_LABEL, USER_LABEL, USER_PROPERTIES_PROP, VIEW_ACTION_PROP`

### Fields inherited from interface org.eclipse.birt.report.model.elements.interfaces.IInternalReportDesignModel

`ACL_EXPRESSION_PROP, AFTER_FACTORY_METHOD, AFTER_RENDER_METHOD, BEFORE_FACTORY_METHOD, BEFORE_RENDER_METHOD, BIDI_ORIENTATION_PROP, BODY_SLOT, CASCADE_ACL_PROP, CHARSET, CHEAT_SHEET_PROP, CLIENT_INITIALIZE_METHOD, CSSES_PROP, CUBE_SLOT, DATA_OBJECTS_PROP, ENABLE_ACL_PROP, EXCEL_AUTO_COL_WIDTHS_INCLUDE_TABLE_FOOTER, EXCEL_AUTO_COL_WIDTHS_INCLUDE_TABLE_HEADER, EXCEL_AUTO_FILTER, EXCEL_DISABLE_GROUPING, EXCEL_DISPLAY_GRIDLINES, EXCEL_FORCE_AUTO_COL_WIDTHS, EXCEL_FORCE_RECALCULATION, EXCEL_IMAGE_SCALING_CELL_DIMENSION, EXCEL_PRINT_PAGES_HIGH, EXCEL_PRINT_PAGES_WIDE, EXCEL_PRINT_SCALE, EXCEL_SINGLE_SHEET, EXCEL_SINGLE_SHEET_WITH_PAGE_BREAK, EXCEL_STREAMING_XLSX, EXCEL_STRUCTURED_HEADER, EXCEL_TEMPLATE_FILE, EXTERNAL_METADATA_PROP, ICON_FILE_PROP, IMAGE_DPI_PROP, LANGUAGE_PROP, LAYOUT_PREFERENCE_PROP, LOCALE_PROP, ON_PAGE_END_METHOD, ON_PAGE_START_METHOD, ON_PREPARE_METHOD, PAGE_VARIABLES_PROP, PDF_CONFORMANCE, PDF_DOCUMENTS_APPEND, PDF_DOCUMENTS_PREPEND, PDF_FONT_CID_SET, PDF_ICC_COLOR_TYPE, PDF_ICC_PROFILE_EXTERNAL, PDF_UA_CONFORMANCE, PDF_VERSION, PDFA_DOCUMENT_EMBED_TITLE, PDFA_FONT_FALLBACK, REFRESH_RATE_PROP, SCRATCH_PAD_SLOT, SLOT_COUNT, STYLE_SLOT, TEMPLATE_PARAMETER_DEFINITION_SLOT, THEMES_SLOT, THUMBNAIL_PROP, WORD_COMBINE_MARGIN_PADDING, WORD_LIST_CELL_ADD_EMPTY_PARA, WORD_TABLE_CELL_ADD_EMPTY_PARA, WORD_WRAP_TABLE_FOR_HEADER_FOOTER, WORD_WRAP_TABLE_FOR_MARGIN_PADDING`

### Fields inherited from interface org.eclipse.birt.report.model.api.core.IModuleModel

`AUTHOR_PROP, BASE_PROP, COLOR_PALETTE_PROP, COMPONENT_SLOT, CONFIG_VARS_PROP, CREATED_BY_PROP, DATA_SET_SLOT, DATA_SOURCE_SLOT, DESCRIPTION_ID_PROP, DESCRIPTION_PROP, HELP_GUIDE_PROP, IMAGES_PROP, INCLUDE_RESOURCE_PROP, INCLUDE_SCRIPTS_PROP, INITIALIZE_METHOD, LIBRARIES_PROP, PAGE_SLOT, PARAMETER_SLOT, PROPERTY_BINDINGS_PROP, SCRIPTLIBS_PROP, SUBJECT_PROP, THEME_PROP, TITLE_ID_PROP, TITLE_PROP, UNITS_PROP`

## Constructor Summary

Constructors
Constructor
Description
`ReportDesignHandle(org.eclipse.birt.report.model.elements.ReportDesign design)`
Constructs a handle with the given design.

## Method Summary

Modifier and Type
Method
Description
`void`
`addConfigVariable(ConfigVariable configVar)`
Adds a new config variable.
`void`
`addCss(String fileName)`
Deprecated.
`void`
`addCss(CssStyleSheetHandle sheetHandle)`
Includes one css with the given css file name.
`void`
`addCss(IncludedCssStyleSheet cssStruct)`
Includes one CSS structure with the given IncludedCssStyleSheet.
`void`
`addCssByProperties(String fileName, String externalCssURI, boolean useExternalCss)`
Includes one css with the given css file name.
`void`
`addImage(EmbeddedImage image)`
Adds a new embedded image.
`void`
`addTranslation(String resourceKey, String locale, String text)`
Adds a new translation to the design.
`void`
`addVariable(VariableElementHandle variable)`
Adds data variable that user defined on the report design.
`void`
`cacheValues()`
Caches values for all elements, styles, etc.
`boolean`
`canAddCssStyleSheet(String fileName)`
Deprecated.
`boolean`
`canAddCssStyleSheet(CssStyleSheetHandle sheetHandle)`
Check style sheet can be added or not.
`boolean`
`canAddCssStyleSheetByProperties(String fileName, String externalCssURI, boolean useExternalCss)`
Check style sheet can be added or not.
`boolean`
`canDropCssStyleSheet(CssStyleSheetHandle sheetHandle)`
Check style sheet can be droped or not.
`boolean`
`canRenameCss(IncludedCssStyleSheetHandle handle, String newFileName)`
Deprecated.
`boolean`
`canRenameCssByProperties(IncludedCssStyleSheetHandle handle, String fileName, String externalCssURI, boolean useExternalCss)`
Checks css can be renamed or not.
`boolean`
`cascadeACL()`
Returns `true` (the default), the design's ACL is automatically propagated to all its directly contained child elements and are added to their ACLs.
`void`
`deleteThumbnail()`
Deletes the thumbnail image in the design.
`void`
`dropConfigVariable(String name)`
Drops a config variable.
`void`
`dropCss(CssStyleSheetHandle sheetHandle)`
Drops the given css style sheet of this design file.
`void`
`dropImage(String name)`
Drops an embedded image from the design.
`void`
`dropImage(List images)`
Drops an embedded image handle list from the design.
`void`
`dropLibrary(LibraryHandle library)`
Drops the given library from the included libraries of this design file.
`void`
`dropLibraryAndBreakExtends(LibraryHandle library)`
Drops the given library from the design and break all the parent/child relationships.
`void`
`dropTranslation(String resourceKey, String locale)`
Drops a translation from the design.
`void`
`dropVariable(VariableElementHandle variable)`
Removes the given data variable.
`CssStyleSheetHandle`
`findCssStyleSheetHandleByFileName(String fileName)`
Deprecated.
`CssStyleSheetHandle`
`findCssStyleSheetHandleByProperties(String fileName, String externalCssURI, boolean useExternalCss)`
Gets `CssStyleSheetHandle` by file name.
`IncludedCssStyleSheetHandle`
`findIncludedCssStyleSheetHandleByFileName(String fileName)`
Deprecated.
`IncludedCssStyleSheetHandle`
`findIncludedCssStyleSheetHandleByProperties(String fileName, String externalCssURI, boolean useExternalCss)`
Gets `IncludedCssStyleSheetHandle` by properties.
`String`
`getACLExpression()`
Returns the ACL expression associated with the design instance.
`String`
`getAfterFactory()`
Returns the script called at the end of the Factory after closing the report document (if any).
`String`
`getAfterRender()`
Returns the script called after starting a presentation time action.
`List<String>`
`getAllBookmarks()`
Gets all bookmarks defined in this module.
`List<CssStyleSheetHandle>`
`getAllCssStyleSheets()`
Gets all CSS styles sheet
`List<IncludedCssStyleSheetHandle>`
`getAllExternalIncludedCsses()`
Gets the list of the included css style sheets that set the external URI.
`List`
`getAllPages()`
Returns all page handles that this modules and the included modules contain.
`List`
`getAllStyles()`
Returns all style element handles that this modules and the included modules contain.
`List<String>`
`getAllTocs()`
Gets all TOCs defined in this module.
`List<VariableElementHandle>`
`getAllVariables()`
Gets all variable.
`String`
`getBase()`
Returns the base directory to use when computing relative links from this report.
`String`
`getBeforeFactory()`
Returns the script called at the start of the Factory after the initialize( ) method and before opening the report document (if any).
`String`
`getBeforeRender()`
Returns the script called before starting a presentation time action.
`String`
`getBidiOrientation()`
Gets Bidi orientation value.
`SlotHandle`
`getBody()`
Returns a slot handle to work with the sections in the report's Body slot.
`String`
`getCheatSheet()`
Gets the design cheat sheet file path.
`String`
`getClientInitialize()`
Gets the client-initialize script of the report design.
`SlotHandle`
`getComponents()`
Returns a slot handle to work with the top-level components within the report.
`SlotHandle`
`getCubes()`
Gets the slot handle to work with all cube elements within the report.
`SlotHandle`
`getDataSets()`
Returns a slot handle to work with the data sets within the report.
`SlotHandle`
`getDataSources()`
Returns a slot handle to work with the data sources within the report.
`String`
`getDisplayName()`
Gets the display name.
`String`
`getDisplayNameKey()`
Gets the resource key of the display name.
`boolean`
`getExcelAutoColWidthsIncludeTableFooter()`
Get the auto column width include footer flag for the excel output
`boolean`
`getExcelAutoColWidthsIncludeTableHeader()`
Get the auto column width include header flag for the excel output
`boolean`
`getExcelAutoFilter()`
Get the display of the excel auto filter
`boolean`
`getExcelDisableGrouping()`
Get the configuration for the excel handling of disabled grouping
`boolean`
`getExcelDisplayGridlines()`
Get the configuration for the excel handling to display grid lines
`boolean`
`getExcelForceAutoColWidths()`
Get the configuration for the excel handling of forced auto column width
`boolean`
`getExcelForceRecalculation()`
Get the configuration for the forced recalculation
`boolean`
`getExcelImageScaling()`
Get the configuration for the excel image scaling to cell dimension
`int`
`getExcelPrintPagesHigh()`
Get the configuration for the sheet high
`int`
`getExcelPrintPagesWide()`
Get the configuration for the sheet wide
`int`
`getExcelPrintScale()`
Get the configuration for the page scale
`boolean`
`getExcelSingleSheet()`
Get the configuration for the excel handling of single sheet result
`boolean`
`getExcelSingleSheetPageBreak()`
Get the configuration for additional page break of single sheet
`boolean`
`getExcelStreamingXlsx()`
Get the configuration if data streaming of XLSX is enabled
`boolean`
`getExcelStructuredHeader()`
Get the configuration to display the report header and footer
`String`
`getExcelTemplateFile()`
Get the configuration for the used template file
`DesignElementHandle`
`getFlattenElement(DesignElementHandle elementHandle, String originalName)`
Gets the flatten element by the original name.
`List`
`getFlattenParameters()`
Returns the flatten Parameters/ParameterGroups of the design.
`String`
`getIconFile()`
Gets the design icon/thumbnail file path.
`int`
`getImageDPI()`
Gets the image DPI of the report design.
`String`
`getLanguage()`
Gets the language of the report design.
`String`
`getLayoutPreference()`
Gets the layout preference of this report design.
`com.ibm.icu.util.ULocale`
`getLocale()`
Gets the locale of the report design.
`SlotHandle`
`getMasterPages()`
Returns a slot handle to work with the master pages within the report.
`String`
`getOnPageEnd()`
Gets the script of onPageEnd method.
`String`
`getOnPageStart()`
Gets the script of onPageStart method.
`String`
`getOnPrepare()`
Gets the on-prepare script of the report design.
`VariableElementHandle`
`getPageVariable(String pageVariableName)`
Gets the <VariableElementHandle> according to the input page variable name.
`List<VariableElementHandle>`
`getPageVariables()`
Gets the pageVariables list value which contains `VariableElementHandle`.
`SlotHandle`
`getParameters()`
Returns a slot handle to work with the top-level parameters and parameter groups within the report.
`List`
`getParametersAndParameterGroups()`
Returns parameters and parameter groups on the module.
`String`
`getPdfAEmbedTitle()`
Get the configuration to the embed the title
`String`
`getPdfAFontFallback()`
Get the configuration for the fallback font of PDF/A
`String`
`getPdfConformance()`
Get the configuration for the used template file
`String`
`getPdfDocumentsAppend()`
Get the configuration to append document(s) to the PDF document
`String`
`getPdfDocumentsPrepend()`
Get the configuration to prepend document(s) to the PDF document
`String`
`getPdfFontCidEmbed()`
Get the configuration for the used CIDSet embed option
`String`
`getPdfIccColorProfileExternal()`
Get the configuration for the used external color profile
`String`
`getPdfIccColorType()`
Get the configuration for the used PDF color type
`String`
`getPdfUAConformance()`
Get the configuration for the PDF/UA conformance
`String`
`getPdfVersion()`
Get the configuration for the used PDF version
`int`
`getRefreshRate()`
Returns the refresh rate when viewing the report.
`List<DesignElementHandle>`
`getReportItemsBasedonTempalates()`
Gets report items which holds a template definition, that is, report item in body slot and page slot.
`SlotHandle`
`getScratchPad()`
Returns a slot handle to work with the scratched elements within the report, which are no longer needed or are in the process of rearranged.
`SlotHandle`
`getStyles()`
Returns a slot handle to work with the styles within the report.
`byte[]`
`getThumbnail()`
Gets the thumbnail image encoded in ISO-8859-1.
`List<ReportItemThemeHandle>`
`getVisibleReportItemThemes(int level, String type)`
Returns report item theme handles according the input level.
`List`
`getVisibleThemes(int level)`
Returns theme handles according the input level.
`boolean`
`getWordCombineMarginPadding()`
Get the configuration to the combined usage of margin invalid input: '&' padding for spacing
`boolean`
`getWordListCellAddEmptyPara()`
Get the configuration if an empty paragraph is to use at the end of a list cell
`boolean`
`getWordTableCellAddEmptyPara()`
Get the configuration if an empty paragraph is to use at the end of a table cell
`boolean`
`getWordWrapTableForHeaderFooter()`
Get the configuration to use a layout table for header and footer
`boolean`
`getWordWrapTableForMarginPadding()`
Get the configuration to use a wrapping table for margin and padding
`Iterator`
`imagesIterator()`
Returns the iterator over all embedded images of this module instance.
`void`
`importCssStyles(CssStyleSheetHandle stylesheet, List selectedStyles)`
(non-Javadoc)
`Iterator`
`includeCssesIterator()`
Returns the iterator over all included css style sheets.
`Iterator`
`includeLibrariesIterator()`
Returns the iterator over all included libraries.
`void`
`includeLibrary(String libraryFileName, String namespace)`
Includes one library with the given library file name.
`Iterator`
`includeLibraryScriptsIterator()`
Returns the list of all the included script file of the libraries.
`boolean`
`isDirectionRTL()`
Examines whether the resolved direction of this design element is Right to Left or not.
`boolean`
`isEnableACL()`
Returns `true` if the ACL feature is enable; otherwise false.
`CssStyleSheetHandle`
`openCssStyleSheet(InputStream is)`
Gets the result style sheet with given file name of an external CSS2 resource.
`CssStyleSheetHandle`
`openCssStyleSheet(String fileName)`
Gets the result style sheet with given file name of an external CSS2 resource.
`void`
`reloadCss(CssStyleSheetHandle sheetHandle)`
Reloads the css with the given css file path.
`void`
`reloadLibraries()`
Reloads all libraries this module included.
`void`
`reloadLibrary(String reloadPath)`
Reloads the library with the given library file path.
`void`
`reloadLibrary(LibraryHandle libraryToReload)`
Reloads the library with the given library file path.
`void`
`renameCss(IncludedCssStyleSheetHandle handle, String newFileName)`
Deprecated.
`void`
`renameCssByProperties(IncludedCssStyleSheetHandle handle, String fileName, String externalCssURI, boolean useExternalCss)`
Renames both `IncludedCssStyleSheet` and `CSSStyleSheet`to newFileName.``
`void`
`replaceConfigVariable(ConfigVariable oldVar, ConfigVariable newVar)`
Replaces the old config variable with the new one.
`void`
`replaceImage(EmbeddedImage oldVar, EmbeddedImage newVar)`
Replaces the old embedded image with the new one.
`void`
`setACLExpression(String expr)`
Sets the ACL expression associated with the design instance.
`void`
`setAfterFactory(String value)`
Sets the script called at the end of the Factory after closing the report document (if any).
`void`
`setAfterRender(String value)`
Sets the script called after starting a presentation time action.
`void`
`setBase(String base)`
Sets the base directory to use when computing relative links from this report.
`void`
`setBeforeFactory(String value)`
Sets the script called at the start of the Factory after the initialize( ) method and before opening the report document (if any).
`void`
`setBeforeRender(String value)`
Sets the script called before starting a presentation time action.
`void`
`setBidiOrientation(String bidiOrientation)`
Sets Bidi orientation value.
`void`
`setCascadeACL(boolean cascadeACL)`
Sets the flag to control whether to cascade ACL
`void`
`setCheatSheet(String cheatSheet)`
Sets the design cheat sheet file path.
`void`
`setClientInitialize(String script)`
Sets the client-initialize script of the report design.
`void`
`setDisplayName(String displayName)`
Sets the display name.
`void`
`setDisplayNameKey(String displayNameKey)`
Sets the resource key of the display name.
`void`
`setEnableACL(boolean enableACL)`
Sets the flag to control whether to enable ACL.
`void`
`setExcelAutoColWidthsIncludeTableFooter(boolean autoColWidthsIncludeTableFooter)`
Set the auto column width include footer flag for the excel output
`void`
`setExcelAutoColWidthsIncludeTableHeader(boolean autoColWidthsIncludeTableHeader)`
Set the auto column width include header flag for the excel output
`void`
`setExcelAutoFilter(boolean enableAutoFilter)`
Set the display of the excel auto filter
`void`
`setExcelDisableGrouping(boolean disableGrouping)`
Set the deactivation of the grouping of the excel output
`void`
`setExcelDisplayGridlines(boolean displayGridlines)`
Set the display of grid line for the excel output
`void`
`setExcelForceAutoColWidths(boolean forceAutoColWidths)`
Set the auto column width usage for the excel output
`void`
`setExcelForceRecalculation(boolean forceRecalculation)`
Set the forced recalculation of excel
`void`
`setExcelImageScaling(boolean enableImageScaling)`
Set the display of grid line for the excel output
`void`
`setExcelPrintPagesHigh(int printPagesHigh)`
Set the configuration to set the sheet high to fit the page
`void`
`setExcelPrintPagesWide(int printPagesWide)`
Set the configuration to set the sheet wide to fit the page
`void`
`setExcelPrintScale(int printScale)`
Set the configuration to set the page scale
`void`
`setExcelSingleSheet(boolean singleSheet)`
Set the single sheet usage for the excel output
`void`
`setExcelSingleSheetPageBreak(boolean singleSheetPageBreak)`
Set an additional page break to single sheet
`void`
`setExcelStreamingXlsx(boolean streamingXlsx)`
Set the output method to data streaming
`void`
`setExcelStructuredHeader(boolean structuredHeader)`
Set the display of report header and footer on excel sheet
`void`
`setExcelTemplateFile(String templateFile)`
Set the configuration for the template file
`void`
`setIconFile(String iconFile)`
Sets the design icon/thumbnail file path.
`void`
`setImageDPI(int imageDPI)`
Sets the image DPI of the report design.
`void`
`setLanguage(String language)`
Sets the language of the report design.
`void`
`setLayoutPreference(String layout)`
Sets the layout preference of this report design.
`void`
`setLocale(com.ibm.icu.util.ULocale locale)`
Sets the locale of the report design.
`void`
`setOnPageEnd(String onPageEnd)`
Sets the script of onPageEnd method.
`void`
`setOnPageStart(String onPageStart)`
Sets the script of onPageStart method.
`void`
`setOnPrepare(String script)`
Sets the on-prepare script of the report design.
`void`
`setPageVariable(String pageVariableName, Expression value)`
Sets the page variable value.
`void`
`setPdfAEmbedTitle(boolean embedTitle)`
Set the configuration to the embed the title
`void`
`setPdfAFontFallback(String pdfaFontFallback)`
Set the configuration for the fallback font of PDF/A
`void`
`setPdfConformance(String pdfConformance)`
Set the configuration for used PDF conformance
`void`
`setPdfDocumentsAppend(String appendDocuments)`
Set the configuration to append document(s) to the PDF document
`void`
`setPdfDocumentsPrepend(String prependDocuments)`
Set the configuration to prepend document(s) to the PDF document
`void`
`setPdfFontCidEmbed(String embedCID)`
Set the configuration for the CIDSet embed option
`void`
`setPdfIccColorProfileExternal(String iccProfileExternal)`
Set the configuration for the external color profile
`void`
`setPdfIccColorType(String iccColorType)`
Set the configuration for the ICC color type
`void`
`setPdfUAConformance(String pdfUAConformance)`
Set the configuration for the PDF/UA conformance
`void`
`setPdfVersion(String pdfVersion)`
Set the configuration for the template file
`void`
`setRefreshRate(int rate)`
Sets the refresh rate when viewing the report.
`void`
`setTheme(ThemeHandle theme)`
Sets the theme to a report.
`void`
`setThemeName(String themeName)`
Sets the theme to a report.
`void`
`setThumbnail(byte[] data)`
Sets the thumbnail image encoded in ISO-8859-1.
`void`
`setWordCombineMarginPadding(boolean combineMarginPadding)`
Set the configuration to the combined usage of margin invalid input: '&' padding for spacing
`void`
`setWordListCellAddEmptyPara(boolean addEmptyPara)`
Set the configuration if an empty paragraph is to use at the end of a list cell
`void`
`setWordTableCellAddEmptyPara(boolean addEmptyPara)`
Set the configuration if an empty paragraph is to use at the end of a table cell
`void`
`setWordWrapTableForHeaderFooter(boolean wrapTable)`
Set the configuration to use a layout table for header and footer
`void`
`setWordWrapTableForMarginPadding(boolean wrapTable)`
Set the configuration to use a wrapping table for margin and padding
`void`
`shiftLibrary(LibraryHandle library, int toPosn)`
Shifts the library to new position.

### Methods inherited from class org.eclipse.birt.report.model.api.ModuleHandleImpl

`addAttributeListener, addDisposeListener, addIncludeScript, addResourceChangeListener, addScriptLib, addValidationListener, checkReport, checkReportIfNecessary, close, configVariablesIterator, copy, customColorsIterator, drop, dropAllScriptLibs, dropAndClear, dropIncludeScript, dropScriptLib, dropScriptLib, findCascadingParameterGroup, findColor, findConfigVariable, findCube, findDataSet, findDataSource, findDimension, findElement, findImage, findJointDataSet, findLevel, findLibrary, findMasterPage, findNativeStyle, findParameter, findReportItemTheme, findResource, findResource, findScriptLib, findStyle, findTemplateDataSet, findTheme, generateHandleList, getAllCubes, getAllDataSets, getAllDataSources, getAllImages, getAllIncludeScripts, getAllLibraries, getAllParameters, getAllScriptLibs, getAllSharedDimensions, getAuthor, getCommandStack, getComments, getCreatedBy, getDefaultUnits, getDescription, getDescriptionKey, getDisplayDescription, getElement, getElementByID, getErrorList, getFileEncoding, getFileName, getHelpGuide, getIncludeResource, getIncludeResources, getInitialize, getLibraries, getLibraries, getLibrary, getLineNo, getLineNoByID, getMessage, getMessage, getMessage, getMessageKeys, getNativeStructureList, getOptions, getResourceFolder, getSubject, getSymbolicName, getSystemId, getTheme, getTitle, getTitleKey, getTranslation, getTranslationKeys, getTranslations, getVersion, getVisibleCubes, getVisibleDataSets, getVisibleDataSources, getVisibleImages, getVisibleModules, getWarningList, includeScriptsIterator, initializeModule, isInclude, isReadOnly, needsSave, onSave, removeAttributeListener, removeDisposeListener, removeResourceChangeListener, removeValidationListener, rename, rename, rename, save, saveAs, scriptLibsIterator, serialize, setAuthor, setComments, setCreatedBy, setDefaultUnits, setDescription, setDescriptionKey, setFileName, setHelpGuide, setIncludeResource, setIncludeResources, setInitialize, setOptions, setResourceFolder, setSubject, setSymbolicName, setTitle, setTitleKey, shifIncludeScripts, shiftScriptLibs, sortVisibleElements`

### Methods inherited from class org.eclipse.birt.report.model.api.DesignElementHandle

`add, add, addElement, addElement, addListener, addUserPropertyDefn, cachePropertyHandles, canContain, canContain, canContain, canContain, canDrop, canEdit, canTransformToTemplate, clearAllProperties, clearContents, clearProperty, clientsIterator, copyPropertyTo, createTemplateElement, derivedIterator, doSort, drop, drop, dropAndClear, dropAndClear, dropUserPropertyDefn, findContentSlot, getBooleanProperty, getChoices, getColorProperty, getContainer, getContainerPropertyHandle, getContainerSlotHandle, getContent, getContentCount, getContents, getDefn, getDesign, getDesignHandle, getDimensionProperty, getDisplayLabel, getDisplayLabel, getDisplayProperty, getEffectiveModule, getElementFactory, getElementProperty, getEventHandlerClass, getExpressionProperty, getExtends, getExternalizedValue, getExternalizedValue, getExternalizedValue, getFactoryElementHandle, getFactoryPropertyHandle, getFloatProperty, getFontProperty, getFullName, getHostViewHandle, getID, getIndex, getIntProperty, getListProperty, getListProperty, getMethods, getModule, getModuleHandle, getName, getNumberProperty, getPrivateStyle, getProperty, getPropertyBinding, getPropertyBindingExpression, getPropertyBindings, getPropertyDefn, getPropertyHandle, getPropertyIterator, getQualifiedName, getRoot, getSemanticErrors, getSlot, getStringProperty, getStyle, getTagType, getUserProperties, getUserPropertyDefnHandle, getXPath, hasLocalProperties, hasSemanticError, initializeSlotHandles, isInTemplateParameter, isTemplateParameterValue, isValid, localize, move, move, moveTo, moveTo, moveTo, moveTo, newHandlerOnEachEvent, paste, paste, paste, paste, removeListener, revertToReportItem, revertToTemplate, semanticCheck, setBooleanProperty, setEncryption, setEventHandlerClass, setExpressionProperty, setExtends, setExtendsElement, setExtendsName, setFloatProperty, setIntProperty, setName, setNewHandlerOnEachEvent, setNumberProperty, setProperties, setProperty, setPropertyBinding, setPropertyBinding, setStringProperty, setStyle, setStyleElement, setStyleName, setValid, shift, showError, slotsIterator`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ReportDesignHandle

public ReportDesignHandle(org.eclipse.birt.report.model.elements.ReportDesign design)
Constructs a handle with the given design. The application generally does not create handles directly. Instead, it uses one of the navigation methods available on other element handles.

Parameters:
  `design` - the report design

## Method Details

### getAfterFactory

public String getAfterFactory()
Returns the script called at the end of the Factory after closing the report document (if any). This is the last method called in the Factory.

Returns:
  the script

### getAfterRender

public String getAfterRender()
Returns the script called after starting a presentation time action.

Returns:
  the script

### getBase

public String getBase()
Returns the base directory to use when computing relative links from this report. Especially used for searching images, library and so.

Returns:
  the base directory

### getBeforeFactory

public String getBeforeFactory()
Returns the script called at the start of the Factory after the initialize( ) method and before opening the report document (if any).

Returns:
  the script

### getBeforeRender

public String getBeforeRender()
Returns the script called before starting a presentation time action.

Returns:
  the script

### getBody

public SlotHandle getBody()
Returns a slot handle to work with the sections in the report's Body slot. The order of sections within the slot determines the order in which the sections print.

Returns:
  A handle for working with the report sections.

### getRefreshRate

public int getRefreshRate()
Returns the refresh rate when viewing the report.

Returns:
  the refresh rate

### getScratchPad

public SlotHandle getScratchPad()
Returns a slot handle to work with the scratched elements within the report, which are no longer needed or are in the process of rearranged.

Returns:
  A handle for working with the scratched elements.

### includeLibraryScriptsIterator

public Iterator includeLibraryScriptsIterator()
Returns the list of all the included script file of the libraries. Each one is the instance of `IncludeScriptHandle`

Returns:
  the iterator of included scripts.

### setAfterFactory

public void setAfterFactory(String value)
Sets the script called at the end of the Factory after closing the report document (if any). This is the last method called in the Factory.

Parameters:
  `value` - the script to set.

### setAfterRender

public void setAfterRender(String value)
Sets the script called after starting a presentation time action.

Parameters:
  `value` - the script to set.

### setBase

public void setBase(String base)
Sets the base directory to use when computing relative links from this report. Especially used for searching images, library and so.

Parameters:
  `base` - the base directory to set

### setBeforeFactory

public void setBeforeFactory(String value)
Sets the script called at the start of the Factory after the initialize( ) method and before opening the report document (if any).

Parameters:
  `value` - the script to set.

### setBeforeRender

public void setBeforeRender(String value)
Sets the script called before starting a presentation time action.

Parameters:
  `value` - the script to set.

### setRefreshRate

public void setRefreshRate(int rate)
Sets the refresh rate when viewing the report.

Parameters:
  `rate` - the refresh rate

### getStyles

public SlotHandle getStyles()
Returns a slot handle to work with the styles within the report. Note that the order of the styles within the slot is unimportant.

Returns:
  A handle for working with the styles.

### getAllCssStyleSheets

public List<CssStyleSheetHandle> getAllCssStyleSheets()
Gets all CSS styles sheet

Returns:
  each item is `CssStyleSheetHandle`

### importCssStyles

public void importCssStyles(CssStyleSheetHandle stylesheet, List selectedStyles)
(non-Javadoc)

Overrides:
  `importCssStyles` in class `ModuleHandleImpl`
Parameters:
  `stylesheet` - the style sheet handle that contains all the selected styles
  `selectedStyles` - the selected style list
See Also:
  - `ModuleHandleImpl.importCssStyles(org.eclipse.birt.report.model.api.css.CssStyleSheetHandle, java.util.List)`

### setDisplayNameKey

public void setDisplayNameKey(String displayNameKey) throws SemanticException
Sets the resource key of the display name.

Parameters:
  `displayNameKey` - the resource key of the display name
Throws:
  `SemanticException` - if the display name resource-key property is locked or not defined on this design.

### getDisplayNameKey

public String getDisplayNameKey()
Gets the resource key of the display name.

Returns:
  the resource key of the display name

### setDisplayName

public void setDisplayName(String displayName) throws SemanticException
Sets the display name.

Parameters:
  `displayName` - the display name
Throws:
  `SemanticException` - if the display name property is locked or not defined on this design.

### getDisplayName

public String getDisplayName()
Gets the display name.

Returns:
  the display name

### setIconFile

public void setIconFile(String iconFile) throws SemanticException
Sets the design icon/thumbnail file path.

Parameters:
  `iconFile` - the design icon/thumbnail file path to set
Throws:
  `SemanticException` - if the property is locked or not defined on this design.

### getIconFile

public String getIconFile()
Gets the design icon/thumbnail file path.

Returns:
  the design icon/thumbnail file path

### setCheatSheet

public void setCheatSheet(String cheatSheet) throws SemanticException
Sets the design cheat sheet file path.

Parameters:
  `cheatSheet` - the design cheat sheet file path to set
Throws:
  `SemanticException` - if the property is locked or not defined on this design.

### getCheatSheet

public String getCheatSheet()
Gets the design cheat sheet file path.

Returns:
  the design cheat sheet file path

### setThumbnail

public void setThumbnail(byte[] data) throws SemanticException
Sets the thumbnail image encoded in ISO-8859-1.

Parameters:
  `data` - the thumbnail image to set
Throws:
  `SemanticException` - if the property is locked or not defined on this design.

### getThumbnail

public byte[] getThumbnail()
Gets the thumbnail image encoded in ISO-8859-1.

Returns:
  the thumbnail image

### deleteThumbnail

public void deleteThumbnail() throws SemanticException
Deletes the thumbnail image in the design.

Throws:
  `SemanticException` - if the property is locked or not defined on this design.

### getAllBookmarks

public List<String> getAllBookmarks()
Gets all bookmarks defined in this module.

Returns:
  All bookmarks defined in this module.

### getAllTocs

public List<String> getAllTocs()
Gets all TOCs defined in this module.

Returns:
  All TOCs defined in this module.

### getReportItemsBasedonTempalates

public List<DesignElementHandle> getReportItemsBasedonTempalates()
Gets report items which holds a template definition, that is, report item in body slot and page slot. Notice, nested template items is excluded.

Returns:
  report items which holds a template definition, nested template items is excluded.

### getCubes

public SlotHandle getCubes()
Description copied from class: `ModuleHandleImpl`
Gets the slot handle to work with all cube elements within the report.

Specified by:
  `getCubes` in class `ModuleHandleImpl`
Returns:
  cube slot handle

### getLayoutPreference

public String getLayoutPreference()
Gets the layout preference of this report design. It can be one of the following:

- `DesignChoiceConstants.REPORT_LAYOUT_PREFERENCE_FIXED_LAYOUT`
- `DesignChoiceConstants.REPORT_LAYOUT_PREFERENCE_AUTO_LAYOUT`

Returns:
  layout preference of report design

### setLayoutPreference

public void setLayoutPreference(String layout) throws SemanticException
Sets the layout preference of this report design. The input layout can be one of the following:

- `DesignChoiceConstants.REPORT_LAYOUT_PREFERENCE_FIXED_LAYOUT`
- `DesignChoiceConstants.REPORT_LAYOUT_PREFERENCE_AUTO_LAYOUT`

Parameters:
  `layout` - the layout to set
Throws:
  `SemanticException` - if value is invalid

### includeCssesIterator

public Iterator includeCssesIterator()
Returns the iterator over all included css style sheets. Each one is the instance of `IncludedCssStyleSheetHandle`

Returns:
  the iterator over all included css style sheets.

### findIncludedCssStyleSheetHandleByFileName

@Deprecated public IncludedCssStyleSheetHandle findIncludedCssStyleSheetHandleByFileName(String fileName)
Deprecated.
Gets `IncludedCssStyleSheetHandle` by file name.

Parameters:
  `fileName` - the file name
Returns:
  the includedCssStyleSheet handle.

### findIncludedCssStyleSheetHandleByProperties

public IncludedCssStyleSheetHandle findIncludedCssStyleSheetHandleByProperties(String fileName, String externalCssURI, boolean useExternalCss)
Gets `IncludedCssStyleSheetHandle` by properties.

Parameters:
  `fileName` -
  `externalCssURI` -
  `useExternalCss` -
Returns:
  the includedCssStyleSheet handle.

### findCssStyleSheetHandleByFileName

@Deprecated public CssStyleSheetHandle findCssStyleSheetHandleByFileName(String fileName)
Deprecated.
Gets `CssStyleSheetHandle` by file name.

Parameters:
  `fileName` - the file name.
Returns:
  the cssStyleSheet handle.

### findCssStyleSheetHandleByProperties

public CssStyleSheetHandle findCssStyleSheetHandleByProperties(String fileName, String externalCssURI, boolean useExternalCss)
Gets `CssStyleSheetHandle` by file name.

Parameters:
  `fileName` -
  `externalCssURI` -
  `useExternalCss` -
Returns:
  the cssStyleSheet handle.

### addCss

public void addCss(CssStyleSheetHandle sheetHandle) throws SemanticException
Includes one css with the given css file name. The new css will be appended to the css list.

Parameters:
  `sheetHandle` - css style sheet handle
Throws:
  `SemanticException` - if error is encountered when handling `CssStyleSheet` structure list.

### addCss

@Deprecated public void addCss(String fileName) throws SemanticException
Deprecated.
Includes one css with the given css file name. The new css will be appended to the css list.

Parameters:
  `fileName` - css file name
Throws:
  `SemanticException` - if error is encountered when handling `CssStyleSheet` structure list.

### addCssByProperties

public void addCssByProperties(String fileName, String externalCssURI, boolean useExternalCss) throws SemanticException
Includes one css with the given css file name. The new css will be appended to the css list.

Parameters:
  `fileName` - CSS file name
  `externalCssURI` - external CSS URI
  `useExternalCss` - use external CSS
Throws:
  `SemanticException` - if error is encountered when handling `CssStyleSheet` structure list.

### addCss

public void addCss(IncludedCssStyleSheet cssStruct) throws SemanticException
Includes one CSS structure with the given IncludedCssStyleSheet. The new css will be appended to the CSS list.

Parameters:
  `cssStruct` - the CSS structure
Throws:
  `SemanticException` - if error is encountered when handling `CssStyleSheet` structure list.

### renameCss

@Deprecated public void renameCss(IncludedCssStyleSheetHandle handle, String newFileName) throws SemanticException
Deprecated.
Renames both `IncludedCssStyleSheet` and `CSSStyleSheet`to newFileName.``

Parameters:
  `handle` - the includedCssStyleSheetHandle
  `newFileName` - the new file name
Throws:
  `SemanticException`

### renameCssByProperties

public void renameCssByProperties(IncludedCssStyleSheetHandle handle, String fileName, String externalCssURI, boolean useExternalCss) throws SemanticException
Renames both `IncludedCssStyleSheet` and `CSSStyleSheet`to newFileName.``

Parameters:
  `handle` - the includedCssStyleSheetHandle
  `fileName` - the file name
  `externalCssURI` - external CSS URI
  `useExternalCss` - use external CSS
Throws:
  `SemanticException`

### canRenameCss

@Deprecated public boolean canRenameCss(IncludedCssStyleSheetHandle handle, String newFileName) throws SemanticException
Deprecated.
Checks css can be renamed or not.

Parameters:
  `handle` - the included css style sheet handle.
  `newFileName` - the new file name.
Returns:
  `true` can be renamed.else return `false`
Throws:
  `SemanticException`

### canRenameCssByProperties

public boolean canRenameCssByProperties(IncludedCssStyleSheetHandle handle, String fileName, String externalCssURI, boolean useExternalCss) throws SemanticException
Checks css can be renamed or not.

Parameters:
  `handle` - the included css style sheet handle.
  `fileName` - the file name
  `externalCssURI` - external CSS URI
  `useExternalCss` - use external CSS
Returns:
  `true` can be renamed.else return `false`
Throws:
  `SemanticException`

### dropCss

public void dropCss(CssStyleSheetHandle sheetHandle) throws SemanticException
Drops the given css style sheet of this design file.

Parameters:
  `sheetHandle` - the css to drop
Throws:
  `SemanticException` - if error is encountered when handling `CssStyleSheet` structure list. Or it maybe because that the given css is not found in the design. Or that the css has descedents in the current module

### canDropCssStyleSheet

public boolean canDropCssStyleSheet(CssStyleSheetHandle sheetHandle)
Check style sheet can be droped or not.

Parameters:
  `sheetHandle` -
Returns:
  `true` can be dropped.else return `false`

### canAddCssStyleSheet

public boolean canAddCssStyleSheet(CssStyleSheetHandle sheetHandle)
Check style sheet can be added or not.

Parameters:
  `sheetHandle` -
Returns:
  `true` can be added.else return `false`

### canAddCssStyleSheet

@Deprecated public boolean canAddCssStyleSheet(String fileName)
Deprecated.
Check style sheet can be added or not.

Parameters:
  `fileName` -
Returns:
  `true` can be added.else return `false`

### canAddCssStyleSheetByProperties

public boolean canAddCssStyleSheetByProperties(String fileName, String externalCssURI, boolean useExternalCss)
Check style sheet can be added or not.

Parameters:
  `fileName` -
  `externalCssURI` -
  `useExternalCss` -
Returns:
  `true` can be added.else return `false`

### reloadCss

public void reloadCss(CssStyleSheetHandle sheetHandle) throws SemanticException
Reloads the css with the given css file path. If the css already is included directly, reload it. If the css is not included, exception will be thrown.

Parameters:
  `sheetHandle` - css style sheet handle.
Throws:
  `SemanticException` - if error is encountered when handling `CssStyleSheet` structure list. Or it maybe because that the given css is not found in the design. Or that the css has descedents in the current module

### getBidiOrientation

public String getBidiOrientation()
Gets Bidi orientation value. The return value is defined in `DesignChoiceConstants` and can be one of:

- `BIDI_DIRECTION_LTR`
- `BIDI_DIRECTION_RTL`

Returns:
  the Bidi orientation value

### setBidiOrientation

public void setBidiOrientation(String bidiOrientation) throws SemanticException
Sets Bidi orientation value. The input value is defined in `DesignChoiceConstants` and can be one of:

- `BIDI_DIRECTION_LTR`
- `BIDI_DIRECTION_RTL`

Parameters:
  `bidiOrientation` - orientation value to be set
Throws:
  `SemanticException`

### isDirectionRTL

public boolean isDirectionRTL()
Description copied from class: `DesignElementHandle`
Examines whether the resolved direction of this design element is Right to Left or not.

Overrides:
  `isDirectionRTL` in class `DesignElementHandle`
Returns:
  true if the direction is RTL, false otherwise

### isEnableACL

public boolean isEnableACL()
Returns `true` if the ACL feature is enable; otherwise false. By default, it is `false`.

Returns:
  the flag to control whether to enable ACL

### setEnableACL

public void setEnableACL(boolean enableACL) throws SemanticException
Sets the flag to control whether to enable ACL.

Parameters:
  `enableACL` - true if to enable ACL, otherwise false
Throws:
  `SemanticException` - if the property is locked by masks

### getACLExpression

public String getACLExpression()
Returns the ACL expression associated with the design instance.

Returns:
  the expression in string

### setACLExpression

public void setACLExpression(String expr) throws SemanticException
Sets the ACL expression associated with the design instance.

Parameters:
  `expr` - the expression in string
Throws:
  `SemanticException` - if the property is locked by masks

### cascadeACL

public boolean cascadeACL()
Returns `true` (the default), the design's ACL is automatically propagated to all its directly contained child elements and are added to their ACLs. Otherwise `false`.

Returns:
  the flag to control whether to cascade ACL

### setCascadeACL

public void setCascadeACL(boolean cascadeACL) throws SemanticException
Sets the flag to control whether to cascade ACL

Parameters:
  `cascadeACL` - `true` (the default), a design's ACL is automatically propagated to all its directly contained child elements and are added to their ACLs. Otherwise `false`.
Throws:
  `SemanticException` - if the property is locked by masks

### getImageDPI

public int getImageDPI()
Gets the image DPI of the report design. This property can ensure image in report design may be displayed as same size at design time as at run time.

Returns:
  the value of image DPI.

### setImageDPI

public void setImageDPI(int imageDPI) throws SemanticException
Sets the image DPI of the report design. This property can ensure image in report design may be displayed as same size at design time as at run time.

Parameters:
  `imageDPI` - the value of image DPI.
Throws:
  `SemanticException` - if the property is locked by masks

### getOnPageStart

public String getOnPageStart()
Gets the script of onPageStart method.

Returns:
  the script of onPageStart method.

### setOnPageStart

public void setOnPageStart(String onPageStart) throws SemanticException
Sets the script of onPageStart method.

Parameters:
  `onPageStart` - the script of onPageStart method.
Throws:
  `SemanticException` - if the property is locked by masks.

### getOnPageEnd

public String getOnPageEnd()
Gets the script of onPageEnd method.

Returns:
  the script of onPageEnd method.

### setOnPageEnd

public void setOnPageEnd(String onPageEnd) throws SemanticException
Sets the script of onPageEnd method.

Parameters:
  `onPageEnd` - the script of onPageEnd method.
Throws:
  `SemanticException` - if the property is locked by masks.

### getPageVariables

public List<VariableElementHandle> getPageVariables()
Gets the pageVariables list value which contains `VariableElementHandle`.

Returns:
  the page variables list value.

### getPageVariable

public VariableElementHandle getPageVariable(String pageVariableName)
Gets the <VariableElementHandle> according to the input page variable name.

Parameters:
  `pageVariableName` - the page variable name.
Returns:
  the <VariableElementHandle> according to the input page variable name

### setPageVariable

public void setPageVariable(String pageVariableName, Expression value) throws SemanticException
Sets the page variable value.

Parameters:
  `pageVariableName` - the page variable name.
  `value` - the page variable value.
Throws:
  `SemanticException`

### addVariable

public void addVariable(VariableElementHandle variable) throws SemanticException
Adds data variable that user defined on the report design.

Parameters:
  `variable` - the variable
Throws:
  `SemanticException`

### dropVariable

public void dropVariable(VariableElementHandle variable) throws SemanticException
Removes the given data variable.

Parameters:
  `variable` - the variable
Throws:
  `SemanticException`

### getAllVariables

public List<VariableElementHandle> getAllVariables()
Gets all variable.

Returns:
  the list of variable. Each item is an instance of `VariableElementHandle`.

### getLocale

public com.ibm.icu.util.ULocale getLocale()
Gets the locale of the report design.

Returns:
  the locale of the report design.

### setLocale

public void setLocale(com.ibm.icu.util.ULocale locale) throws SemanticException
Sets the locale of the report design.

Parameters:
  `locale` - the locale of the report design.
Throws:
  `SemanticException`

### getAllExternalIncludedCsses

public List<IncludedCssStyleSheetHandle> getAllExternalIncludedCsses()
Gets the list of the included css style sheets that set the external URI. The css style might be included by the design handle itself and the theme which the design refers. Each item in the list is instance of `IncludedCssStyleSheetHandle`.

Returns:
  list of all the included css style sheet that set the external URI

### cacheValues

public void cacheValues()
Caches values for all elements, styles, etc. The caller must guarantee this method runs in single thread and have no synchronization issue. Whenever the user changes element values, should recall this method.

### getFlattenElement

public DesignElementHandle getFlattenElement(DesignElementHandle elementHandle, String originalName)
Gets the flatten element by the original name.

Parameters:
  `elementHandle` - the handle of a flatten element once in the same namespace
  `originalName` - the original name of the element
Returns:
  the flatten element handle, or null if not found

### getOnPrepare

public String getOnPrepare()
Gets the on-prepare script of the report design. Startup phase. No data binding yet. The design of an element can be changed here.

Returns:
  the on-prepare script of the report design

### setOnPrepare

public void setOnPrepare(String script) throws SemanticException
Sets the on-prepare script of the report design.

Parameters:
  `script` - the script to set
Throws:
  `SemanticException` - if the method is locked.

### getClientInitialize

public String getClientInitialize()
Gets the client-initialize script of the report design. The design can load java script libraries by the property.

Returns:
  the client-initialize script of the report design

### setClientInitialize

public void setClientInitialize(String script) throws SemanticException
Sets the client-initialize script of the report design.

Parameters:
  `script` - the script to set
Throws:
  `SemanticException` - if the method is locked.

### getLanguage

public String getLanguage()
Gets the language of the report design.

Returns:
  the language of the report design

### setLanguage

public void setLanguage(String language) throws SemanticException
Sets the language of the report design.

Parameters:
  `language` - the language to set
Throws:
  `SemanticException` - if the method is locked.

### getExcelForceAutoColWidths

public boolean getExcelForceAutoColWidths()
Get the configuration for the excel handling of forced auto column width

Returns:
  the configuration of forced auto column width

### setExcelForceAutoColWidths

public void setExcelForceAutoColWidths(boolean forceAutoColWidths) throws SemanticException
Set the auto column width usage for the excel output

Parameters:
  `forceAutoColWidths` - auto columns widths calculation to be used
Throws:
  `SemanticException`

### getExcelAutoColWidthsIncludeTableHeader

public boolean getExcelAutoColWidthsIncludeTableHeader()
Get the auto column width include header flag for the excel output

Returns:
  include the header rows in auto columns widths calculation or not

### setExcelAutoColWidthsIncludeTableHeader

public void setExcelAutoColWidthsIncludeTableHeader(boolean autoColWidthsIncludeTableHeader) throws SemanticException
Set the auto column width include header flag for the excel output

Parameters:
  `autoColWidthsIncludeTableHeader` - include header rows in auto columns widths calculation
Throws:
  `SemanticException`

### getExcelAutoColWidthsIncludeTableFooter

public boolean getExcelAutoColWidthsIncludeTableFooter()
Get the auto column width include footer flag for the excel output

Returns:
  include the footer row in auto columns widths calculation or not

### setExcelAutoColWidthsIncludeTableFooter

public void setExcelAutoColWidthsIncludeTableFooter(boolean autoColWidthsIncludeTableFooter) throws SemanticException
Set the auto column width include footer flag for the excel output

Parameters:
  `autoColWidthsIncludeTableFooter` - include footer row in auto columns widths calculation
Throws:
  `SemanticException`

### getExcelSingleSheet

public boolean getExcelSingleSheet()
Get the configuration for the excel handling of single sheet result

Returns:
  the configuration of single sheet result

### setExcelSingleSheet

public void setExcelSingleSheet(boolean singleSheet) throws SemanticException
Set the single sheet usage for the excel output

Parameters:
  `singleSheet` - single sheet to be used
Throws:
  `SemanticException`

### getExcelDisableGrouping

public boolean getExcelDisableGrouping()
Get the configuration for the excel handling of disabled grouping

Returns:
  the configuration of disabled grouping

### setExcelDisableGrouping

public void setExcelDisableGrouping(boolean disableGrouping) throws SemanticException
Set the deactivation of the grouping of the excel output

Parameters:
  `disableGrouping` - disable grouping
Throws:
  `SemanticException`

### getExcelDisplayGridlines

public boolean getExcelDisplayGridlines()
Get the configuration for the excel handling to display grid lines

Returns:
  the configuration to display grind lines

### setExcelDisplayGridlines

public void setExcelDisplayGridlines(boolean displayGridlines) throws SemanticException
Set the display of grid line for the excel output

Parameters:
  `displayGridlines` - display grid lines
Throws:
  `SemanticException`

### getExcelAutoFilter

public boolean getExcelAutoFilter()
Get the display of the excel auto filter

Returns:
  the configuration to display the auto filter

### setExcelAutoFilter

public void setExcelAutoFilter(boolean enableAutoFilter) throws SemanticException
Set the display of the excel auto filter

Parameters:
  `enableAutoFilter` - enable auto filter
Throws:
  `SemanticException`

### getExcelForceRecalculation

public boolean getExcelForceRecalculation()
Get the configuration for the forced recalculation

Returns:
  the configuration to display grind lines

### setExcelForceRecalculation

public void setExcelForceRecalculation(boolean forceRecalculation) throws SemanticException
Set the forced recalculation of excel

Parameters:
  `forceRecalculation` - enable the forced recalculation
Throws:
  `SemanticException`

### getExcelImageScaling

public boolean getExcelImageScaling()
Get the configuration for the excel image scaling to cell dimension

Returns:
  the configuration to use the image scaling

### setExcelImageScaling

public void setExcelImageScaling(boolean enableImageScaling) throws SemanticException
Set the display of grid line for the excel output

Parameters:
  `enableImageScaling` - enable image scaling
Throws:
  `SemanticException`

### getExcelSingleSheetPageBreak

public boolean getExcelSingleSheetPageBreak()
Get the configuration for additional page break of single sheet

Returns:
  the configuration for additional page break of single sheet

### setExcelSingleSheetPageBreak

public void setExcelSingleSheetPageBreak(boolean singleSheetPageBreak) throws SemanticException
Set an additional page break to single sheet

Parameters:
  `singleSheetPageBreak` - add the single sheet page break
Throws:
  `SemanticException`

### getExcelStreamingXlsx

public boolean getExcelStreamingXlsx()
Get the configuration if data streaming of XLSX is enabled

Returns:
  the configuration if data streaming of XLSX is enabled

### setExcelStreamingXlsx

public void setExcelStreamingXlsx(boolean streamingXlsx) throws SemanticException
Set the output method to data streaming

Parameters:
  `streamingXlsx` - enable the XLSX streaming
Throws:
  `SemanticException`

### getExcelStructuredHeader

public boolean getExcelStructuredHeader()
Get the configuration to display the report header and footer

Returns:
  the configuration to display the report header and footer

### setExcelStructuredHeader

public void setExcelStructuredHeader(boolean structuredHeader) throws SemanticException
Set the display of report header and footer on excel sheet

Parameters:
  `structuredHeader` - display report header and footer at excel sheet
Throws:
  `SemanticException`

### getExcelPrintPagesWide

public int getExcelPrintPagesWide()
Get the configuration for the sheet wide

Returns:
  the configuration for the sheet wide

### setExcelPrintPagesWide

public void setExcelPrintPagesWide(int printPagesWide) throws SemanticException
Set the configuration to set the sheet wide to fit the page

Parameters:
  `printPagesWide` - the page wide
Throws:
  `SemanticException`

### getExcelPrintPagesHigh

public int getExcelPrintPagesHigh()
Get the configuration for the sheet high

Returns:
  the configuration for the sheet high

### setExcelPrintPagesHigh

public void setExcelPrintPagesHigh(int printPagesHigh) throws SemanticException
Set the configuration to set the sheet high to fit the page

Parameters:
  `printPagesHigh` - the page high
Throws:
  `SemanticException`

### getExcelPrintScale

public int getExcelPrintScale()
Get the configuration for the page scale

Returns:
  the configuration for the page scale

### setExcelPrintScale

public void setExcelPrintScale(int printScale) throws SemanticException
Set the configuration to set the page scale

Parameters:
  `printScale` - the page scale
Throws:
  `SemanticException`

### getExcelTemplateFile

public String getExcelTemplateFile()
Get the configuration for the used template file

Returns:
  the configuration for the used template file

### setExcelTemplateFile

public void setExcelTemplateFile(String templateFile) throws SemanticException
Set the configuration for the template file

Parameters:
  `templateFile` - template file
Throws:
  `SemanticException`

### getPdfVersion

public String getPdfVersion()
Get the configuration for the used PDF version

Returns:
  the configuration for the used PDF version

### setPdfVersion

public void setPdfVersion(String pdfVersion) throws SemanticException
Set the configuration for the template file

Parameters:
  `pdfVersion` - PDF version number
Throws:
  `SemanticException`

### getPdfConformance

public String getPdfConformance()
Get the configuration for the used template file

Returns:
  the configuration for used PDF conformance

### setPdfConformance

public void setPdfConformance(String pdfConformance) throws SemanticException
Set the configuration for used PDF conformance

Parameters:
  `pdfConformance` - PDF conformance
Throws:
  `SemanticException`

### getPdfUAConformance

public String getPdfUAConformance()
Get the configuration for the PDF/UA conformance

Returns:
  the configuration for the PDF/UA conformance

### setPdfUAConformance

public void setPdfUAConformance(String pdfUAConformance) throws SemanticException
Set the configuration for the PDF/UA conformance

Parameters:
  `pdfUAConformance` - PDF/UA conformance
Throws:
  `SemanticException`

### getPdfIccColorType

public String getPdfIccColorType()
Get the configuration for the used PDF color type

Returns:
  the configuration for the used PDF color type

### setPdfIccColorType

public void setPdfIccColorType(String iccColorType) throws SemanticException
Set the configuration for the ICC color type

Parameters:
  `iccColorType` - ICC color type
Throws:
  `SemanticException`

### getPdfIccColorProfileExternal

public String getPdfIccColorProfileExternal()
Get the configuration for the used external color profile

Returns:
  the configuration for the used external color profile

### setPdfIccColorProfileExternal

public void setPdfIccColorProfileExternal(String iccProfileExternal) throws SemanticException
Set the configuration for the external color profile

Parameters:
  `iccProfileExternal` - external color profile
Throws:
  `SemanticException`

### getPdfDocumentsPrepend

public String getPdfDocumentsPrepend()
Get the configuration to prepend document(s) to the PDF document

Returns:
  the configuration to prepend document(s) to the PDF document

### setPdfDocumentsPrepend

public void setPdfDocumentsPrepend(String prependDocuments) throws SemanticException
Set the configuration to prepend document(s) to the PDF document

Parameters:
  `prependDocuments` - document(s) to prepend
Throws:
  `SemanticException`

### getPdfDocumentsAppend

public String getPdfDocumentsAppend()
Get the configuration to append document(s) to the PDF document

Returns:
  the configuration to append document(s) to the PDF document

### setPdfDocumentsAppend

public void setPdfDocumentsAppend(String appendDocuments) throws SemanticException
Set the configuration to append document(s) to the PDF document

Parameters:
  `appendDocuments` - document(s) to append
Throws:
  `SemanticException`

### getPdfAFontFallback

public String getPdfAFontFallback()
Get the configuration for the fallback font of PDF/A

Returns:
  the configuration for the fallback font of PDF/A

### setPdfAFontFallback

public void setPdfAFontFallback(String pdfaFontFallback) throws SemanticException
Set the configuration for the fallback font of PDF/A

Parameters:
  `pdfaFontFallback` - PDF/A fallback font
Throws:
  `SemanticException`

### getPdfFontCidEmbed

public String getPdfFontCidEmbed()
Get the configuration for the used CIDSet embed option

Returns:
  the configuration for the used CIDSet embed option

### setPdfFontCidEmbed

public void setPdfFontCidEmbed(String embedCID) throws SemanticException
Set the configuration for the CIDSet embed option

Parameters:
  `embedCID` - font embed CIDSet
Throws:
  `SemanticException`

### getPdfAEmbedTitle

public String getPdfAEmbedTitle()
Get the configuration to the embed the title

Returns:
  the configuration to the embed the title

### setPdfAEmbedTitle

public void setPdfAEmbedTitle(boolean embedTitle) throws SemanticException
Set the configuration to the embed the title

Parameters:
  `embedTitle` - embed title
Throws:
  `SemanticException`

### getWordCombineMarginPadding

public boolean getWordCombineMarginPadding()
Get the configuration to the combined usage of margin invalid input: '&' padding for spacing

Returns:
  the configuration to use the combined calculation of margin invalid input: '&' padding

### setWordCombineMarginPadding

public void setWordCombineMarginPadding(boolean combineMarginPadding) throws SemanticException
Set the configuration to the combined usage of margin invalid input: '&' padding for spacing

Parameters:
  `combineMarginPadding` - use combination of margin invalid input: '&' padding for spacing
Throws:
  `SemanticException`

### getWordListCellAddEmptyPara

public boolean getWordListCellAddEmptyPara()
Get the configuration if an empty paragraph is to use at the end of a list cell

Returns:
  the configuration if an empty paragraph is to use at the end of a list cell

### setWordListCellAddEmptyPara

public void setWordListCellAddEmptyPara(boolean addEmptyPara) throws SemanticException
Set the configuration if an empty paragraph is to use at the end of a list cell

Parameters:
  `addEmptyPara` - add empty paragraph
Throws:
  `SemanticException`

### getWordTableCellAddEmptyPara

public boolean getWordTableCellAddEmptyPara()
Get the configuration if an empty paragraph is to use at the end of a table cell

Returns:
  the configuration if an empty paragraph is to use at the end of a table cell

### setWordTableCellAddEmptyPara

public void setWordTableCellAddEmptyPara(boolean addEmptyPara) throws SemanticException
Set the configuration if an empty paragraph is to use at the end of a table cell

Parameters:
  `addEmptyPara` - add empty paragraph
Throws:
  `SemanticException`

### getWordWrapTableForMarginPadding

public boolean getWordWrapTableForMarginPadding()
Get the configuration to use a wrapping table for margin and padding

Returns:
  the configuration to use a wrapping table for margin and padding

### setWordWrapTableForMarginPadding

public void setWordWrapTableForMarginPadding(boolean wrapTable) throws SemanticException
Set the configuration to use a wrapping table for margin and padding

Parameters:
  `wrapTable` - wrap table for margin and padding
Throws:
  `SemanticException`

### getWordWrapTableForHeaderFooter

public boolean getWordWrapTableForHeaderFooter()
Get the configuration to use a layout table for header and footer

Returns:
  the configuration to use a layout table for header and footer

### setWordWrapTableForHeaderFooter

public void setWordWrapTableForHeaderFooter(boolean wrapTable) throws SemanticException
Set the configuration to use a layout table for header and footer

Parameters:
  `wrapTable` - layout table for header and footer
Throws:
  `SemanticException`

### addConfigVariable

public void addConfigVariable(ConfigVariable configVar) throws SemanticException
Description copied from class: `ModuleHandleImpl`
Adds a new config variable.

Overrides:
  `addConfigVariable` in class `ModuleHandleImpl`
Parameters:
  `configVar` - the config variable
Throws:
  `SemanticException` - if the name is empty or the same name exists.

### addImage

public void addImage(EmbeddedImage image) throws SemanticException
Description copied from class: `ModuleHandleImpl`
Adds a new embedded image.

Overrides:
  `addImage` in class `ModuleHandleImpl`
Parameters:
  `image` - the image to add
Throws:
  `SemanticException` - if the name is empty, type is invalid, or the same name exists.

### addTranslation

public void addTranslation(String resourceKey, String locale, String text) throws CustomMsgException
Description copied from class: `ModuleHandleImpl`
Adds a new translation to the design.

Overrides:
  `addTranslation` in class `ModuleHandleImpl`
Parameters:
  `resourceKey` - resource key for the message
  `locale` - the string value of a locale for the translation. Locale should be in java-defined format( en, en-US, zh_CN, etc.)
  `text` - translated text for the locale
Throws:
  `CustomMsgException` - if the resource key is duplicate or missing, or locale is not a valid format.
See Also:
  - `ModuleHandleImpl.getTranslation(String, String)`

### dropConfigVariable

public void dropConfigVariable(String name) throws SemanticException
Description copied from class: `ModuleHandleImpl`
Drops a config variable.

Overrides:
  `dropConfigVariable` in class `ModuleHandleImpl`
Parameters:
  `name` - config variable name
Throws:
  `SemanticException` - if no config variable is found.

### dropImage

public void dropImage(List images) throws SemanticException
Description copied from class: `ModuleHandleImpl`
Drops an embedded image handle list from the design. Each one in the list is the instance of `EmbeddedImageHandle`.

Overrides:
  `dropImage` in class `ModuleHandleImpl`
Parameters:
  `images` - the image handle list to remove
Throws:
  `SemanticException` - if any image in the list is not found.

### dropImage

public void dropImage(String name) throws SemanticException
Description copied from class: `ModuleHandleImpl`
Drops an embedded image from the design.

Overrides:
  `dropImage` in class `ModuleHandleImpl`
Parameters:
  `name` - the image name
Throws:
  `SemanticException` - if the image is not found.

### dropTranslation

public void dropTranslation(String resourceKey, String locale) throws CustomMsgException
Description copied from class: `ModuleHandleImpl`
Drops a translation from the design.

Overrides:
  `dropTranslation` in class `ModuleHandleImpl`
Parameters:
  `resourceKey` - resource key of the message in which this translation saves.
  `locale` - the string value of the locale for a translation. Locale should be in java-defined format( en, en-US, zh_CN, etc.)
Throws:
  `CustomMsgException` - if `resourceKey` is `null`.
See Also:
  - `ModuleHandleImpl.getTranslation(String, String)`

### getComponents

public SlotHandle getComponents()
Description copied from class: `ModuleHandleImpl`
Returns a slot handle to work with the top-level components within the report.

Overrides:
  `getComponents` in class `ModuleHandleImpl`
Returns:
  A handle for working with the components.

### getDataSets

public SlotHandle getDataSets()
Description copied from class: `ModuleHandleImpl`
Returns a slot handle to work with the data sets within the report. Note that the order of the data sets within the slot is unimportant.

Overrides:
  `getDataSets` in class `ModuleHandleImpl`
Returns:
  A handle for working with the data sets.

### getDataSources

public SlotHandle getDataSources()
Description copied from class: `ModuleHandleImpl`
Returns a slot handle to work with the data sources within the report. Note that the order of the data sources within the slot is unimportant.

Overrides:
  `getDataSources` in class `ModuleHandleImpl`
Returns:
  A handle for working with the data sources.

### getFlattenParameters

public List getFlattenParameters()
Description copied from class: `ModuleHandleImpl`
Returns the flatten Parameters/ParameterGroups of the design. This method put all Parameters and ParameterGroups into a list then return it. The return list is sorted by on the display name of the parameters.

Overrides:
  `getFlattenParameters` in class `ModuleHandleImpl`
Returns:
  the sorted, flatten parameters and parameter groups.

### getMasterPages

public SlotHandle getMasterPages()
Description copied from class: `ModuleHandleImpl`
Returns a slot handle to work with the master pages within the report. Note that the order of the master pages within the slot is unimportant.

Overrides:
  `getMasterPages` in class `ModuleHandleImpl`
Returns:
  A handle for working with the master pages.

### getParameters

public SlotHandle getParameters()
Description copied from class: `ModuleHandleImpl`
Returns a slot handle to work with the top-level parameters and parameter groups within the report. The order that the items appear within the slot determines the order in which they appear in the "requester" UI.

Overrides:
  `getParameters` in class `ModuleHandleImpl`
Returns:
  A handle for working with the parameters and parameter groups.

### imagesIterator

public Iterator imagesIterator()
Description copied from class: `ModuleHandleImpl`
Returns the iterator over all embedded images of this module instance. Each one is the instance of `EmbeddedImageHandle`

Overrides:
  `imagesIterator` in class `ModuleHandleImpl`
Returns:
  the iterator over all embedded images.
See Also:
  - `EmbeddedImageHandle`

### replaceConfigVariable

public void replaceConfigVariable(ConfigVariable oldVar, ConfigVariable newVar) throws SemanticException
Description copied from class: `ModuleHandleImpl`
Replaces the old config variable with the new one.

Overrides:
  `replaceConfigVariable` in class `ModuleHandleImpl`
Parameters:
  `oldVar` - the old config variable
  `newVar` - the new config variable
Throws:
  `SemanticException` - if the old config variable is not found or the name of new one is empty.

### replaceImage

public void replaceImage(EmbeddedImage oldVar, EmbeddedImage newVar) throws SemanticException
Description copied from class: `ModuleHandleImpl`
Replaces the old embedded image with the new one.

Overrides:
  `replaceImage` in class `ModuleHandleImpl`
Parameters:
  `oldVar` - the old embedded image
  `newVar` - the new embedded image
Throws:
  `SemanticException` - if the old image is not found or the name of new one is empty.

### getAllStyles

public List getAllStyles()
Description copied from class: `ModuleHandleImpl`
Returns all style element handles that this modules and the included modules contain.

Overrides:
  `getAllStyles` in class `ModuleHandleImpl`
Returns:
  all style element handles that this modules and the included modules contain.

### getVisibleThemes

public List getVisibleThemes(int level)
Description copied from class: `ModuleHandleImpl`
Returns theme handles according the input level.

Overrides:
  `getVisibleThemes` in class `ModuleHandleImpl`
Parameters:
  `level` - an `int` value, which should be the one defined in `IVisibleLevelControl`.
Returns:
  theme handles according the input level

### getVisibleReportItemThemes

public List<ReportItemThemeHandle> getVisibleReportItemThemes(int level, String type)
Description copied from class: `ModuleHandleImpl`
Returns report item theme handles according the input level.

Overrides:
  `getVisibleReportItemThemes` in class `ModuleHandleImpl`
Parameters:
  `level` - an `int` value, which should be the one defined in `IVisibleLevelControl`.
Returns:
  theme handles according the input level

### getParametersAndParameterGroups

public List getParametersAndParameterGroups()
Description copied from class: `ModuleHandleImpl`
Returns parameters and parameter groups on the module. Those parameters included in the parameter groups are not included in the return list.

Overrides:
  `getParametersAndParameterGroups` in class `ModuleHandleImpl`
Returns:
  parameters and parameter groups

### getAllPages

public List getAllPages()
Description copied from class: `ModuleHandleImpl`
Returns all page handles that this modules and the included modules contain.

Overrides:
  `getAllPages` in class `ModuleHandleImpl`
Returns:
  all page handles that this modules and the included modules contain.

### shiftLibrary

public void shiftLibrary(LibraryHandle library, int toPosn) throws SemanticException
Description copied from class: `ModuleHandleImpl`
Shifts the library to new position. This method might affect the style reference, because the library order is changed.

Overrides:
  `shiftLibrary` in class `ModuleHandleImpl`
Parameters:
  `library` - the library to shift
  `toPosn` - the new position
Throws:
  `SemanticException` - if error is encountered when shifting

### includeLibrariesIterator

public Iterator includeLibrariesIterator()
Description copied from class: `ModuleHandleImpl`
Returns the iterator over all included libraries. Each one is the instance of `IncludeLibraryHandle`

Overrides:
  `includeLibrariesIterator` in class `ModuleHandleImpl`
Returns:
  the iterator over all included libraries.
See Also:
  - `IncludedLibraryHandle`

### includeLibrary

public void includeLibrary(String libraryFileName, String namespace) throws DesignFileException, SemanticException
Description copied from class: `ModuleHandleImpl`
Includes one library with the given library file name. The new library will be appended to the library list.

Overrides:
  `includeLibrary` in class `ModuleHandleImpl`
Parameters:
  `libraryFileName` - library file name
  `namespace` - library namespace
Throws:
  `DesignFileException` - if the library file is not found, or has fatal error.
  `SemanticException` - if error is encountered when handling `IncludeLibrary` structure list.

### dropLibrary

public void dropLibrary(LibraryHandle library) throws SemanticException
Description copied from class: `ModuleHandleImpl`
Drops the given library from the included libraries of this design file.

Overrides:
  `dropLibrary` in class `ModuleHandleImpl`
Parameters:
  `library` - the library to drop
Throws:
  `SemanticException` - if error is encountered when handling `IncludeLibrary` structure list. Or it maybe because that the given library is not found in the design. Or that the library has descedents in the current module

### reloadLibrary

public void reloadLibrary(LibraryHandle libraryToReload) throws SemanticException, DesignFileException
Description copied from class: `ModuleHandleImpl`
Reloads the library with the given library file path. If the library already is included directly, reload it. If the library is not included, exception will be thrown.

Call this method cautiously ONLY on the condition that the library file is REALLY changed outside. After reload successfully, the command stack is cleared.

Overrides:
  `reloadLibrary` in class `ModuleHandleImpl`
Parameters:
  `libraryToReload` - the library instance
Throws:
  `SemanticException` - if error is encountered when handling `IncludeLibrary` structure list. Or it maybe because that the given library is not found in the design. Or that the library has descedents in the current module
  `DesignFileException` - if the library file is not found, or has fatal error.

### reloadLibraries

public void reloadLibraries() throws SemanticException, DesignFileException
Description copied from class: `ModuleHandleImpl`
Reloads all libraries this module included.

Call this method cautiously ONLY on the condition that the library file is REALLY changed outside. After reload successfully, the command stack is cleared. `ModuleHandleImpl.reloadLibrary(LibraryHandle)`

Overrides:
  `reloadLibraries` in class `ModuleHandleImpl`
Throws:
  `SemanticException`
  `DesignFileException`

### reloadLibrary

public void reloadLibrary(String reloadPath) throws SemanticException, DesignFileException
Description copied from class: `ModuleHandleImpl`
Reloads the library with the given library file path. If the library already is included directly or indirectly(that is, the reload path could be the path of grandson of this module), reload it. If the library is not included, exception will be thrown.

Call this method cautiously ONLY on the condition that the library file is REALLY changed outside. After reload successfully, the command stack is cleared.

Overrides:
  `reloadLibrary` in class `ModuleHandleImpl`
Parameters:
  `reloadPath` - this is supposed to be an absolute path, not in url form.
Throws:
  `SemanticException` - if error is encountered when handling `IncludeLibrary` structure list. Or it maybe because that the given library is not found in the design. Or that the library has descedents in the current module
  `DesignFileException` - if the library file is not found, or has fatal error.

### dropLibraryAndBreakExtends

public void dropLibraryAndBreakExtends(LibraryHandle library) throws SemanticException
Description copied from class: `ModuleHandleImpl`
Drops the given library from the design and break all the parent/child relationships. All child element will be localized in the module.

Overrides:
  `dropLibraryAndBreakExtends` in class `ModuleHandleImpl`
Parameters:
  `library` - the given library to drop
Throws:
  `SemanticException` - if errors occured when drop the library.It may be because that the library is not found in the design or that some elements can not be localized properly.

### openCssStyleSheet

public CssStyleSheetHandle openCssStyleSheet(String fileName) throws StyleSheetException
Description copied from class: `ModuleHandleImpl`
Gets the result style sheet with given file name of an external CSS2 resource.

Overrides:
  `openCssStyleSheet` in class `ModuleHandleImpl`
Parameters:
  `fileName` - the file name of the external CSS resource
Returns:
  the `CssStyleSheetHandle` if the external resource is successfully loaded
Throws:
  `StyleSheetException` - thrown if the resource is not found, or there are syntax errors in the resource

### openCssStyleSheet

public CssStyleSheetHandle openCssStyleSheet(InputStream is) throws StyleSheetException
Description copied from class: `ModuleHandleImpl`
Gets the result style sheet with given file name of an external CSS2 resource.

Overrides:
  `openCssStyleSheet` in class `ModuleHandleImpl`
Parameters:
  `is` - the input stream of the resource
Returns:
  the `CssStyleSheetHandle` if the external resource is successfully loaded
Throws:
  `StyleSheetException` - thrown if the resource is not found, or there are syntax errors in the resource

### setThemeName

public void setThemeName(String themeName) throws SemanticException
Description copied from class: `ModuleHandleImpl`
Sets the theme to a report.

Overrides:
  `setThemeName` in class `ModuleHandleImpl`
Parameters:
  `themeName` - the name of the theme
Throws:
  `SemanticException`

### setTheme

public void setTheme(ThemeHandle theme) throws SemanticException
Description copied from class: `ModuleHandleImpl`
Sets the theme to a report.

Overrides:
  `setTheme` in class `ModuleHandleImpl`
Parameters:
  `theme` - the theme instance
Throws:
  `SemanticException`